<!DOCTYPE html>
<html>
    <head>
        <title>This page</title>
    </head>
    <body>
        <script>
            //this scope in a function taken as value in an object
            var firstname = "outname";
            var obj = {
                firstname : "innername",
                name1 : function(){
                    document.write(this.firstname) // Normal function scoped to the object in which it created.
                },
                name2 : () => document.write(this.firstname) // Arrow function scoped globally.
            };
            document.write("function1: ")
            obj.name1();
            document.write("<br>");
            document.write("function2: ");
            obj.name2();
            document.write("<br>");
            // this scope in nested functions
            var fname = "oname";
            function fun1(){
                var fname = "f1iname";
                function fun2(){
                    document.write(this.fname); // Nested function scoped globally
                }
                fun2();
            }
            var afun = () => document.write(this.fname); // scoped globally
            document.write("In nested function ");
            fun1();
            document.write("<br>");
            document.write("Outer arrow function ");
            afun();
            document.write("<br>");
            //other trails
            // trail1
            var firstname = "outname";
            var obj = {
                firstname : "innername",
                name1 : function(){
                    firstname = "inner-innername";
                    document.write(this.firstname) // Normal function scoped to the object in which it created.
                },
                name2 : () => document.write(this.firstname) // Arrow function scoped globally.
            };
            document.write("function1: ")
            obj.name1();
            document.write("<br>");
            document.write("function2: ");
            obj.name2();
            document.write("<br>");
            document.write("out "+firstname+"<br>");
            document.write("<br>");
            //trail2
            var fname1 = "oname";
            function fun11(){
                fun21();
                var fname1 = "f1iname";
                function fun21(){
                    document.write(this.fname1); // Nested function scoped globally
                    document.write("<br>" + "Calling arrow function in inner function ")
                    afun1();
                    document.write("<br>" + "Calling swe function in inner function ")
                    swe();
                    document.write("<br>");

                }
                document.write("<br>" + "Calling swe  function in outer function ")
                swe();
                document.write("<br>" + "Calling arrow function in outer function ")
                afun1();
                document.write("<br>");
                document.write("This inside function1 ");
                document.write(this.fname1);
            }
            var afun1 = () => document.write(this.fname1); // scoped globally
            function swe()
            {
                fname1="swetha";
                document.write(this.fname1);
            }
            document.write("In nested function ");
            fun11();
            document.write("<br>");
            document.write("Outer arrow function ");
            afun1();
            document.write("<br>");
            //trail3
            var b = "global-b";
            function arr_fun(){
                var b = "local-b";
                document.write("arr_fun_bvalue: "+ this.b);
                var arr = () => {
                    document.write("<br>inner-arr-fun-bvale: "+this.b);
                }
                arr();
            }
            arr_fun();
            //trail4
            function f1(){
                var a = "Hello";
                function f2(){
                    a = "hai";
                    document.write("<br>"+this.a);
                }
                document.write("<br>before :"+a);
                f2();
                document.write("<br>after :"+a);
            }
            f1();
            var a = "out";
            var x = () => {
                document.write("<br>thisa_value_x: " + this);
                document.write("<br>a_value_x: " + a);
            }
            x();
            var x1 = () => {
                a = "first in";
                document.write("<br>thisa_value_x1: " + this);
                document.write("<br>a_value_x1: " + a);
                var x2 = () => {
                    a = "second in";
                    document.write("<br>thisa_value_x2: " + this);
                    document.write("<br>a_value_x2: " + a);
                }
                x2();
            }
            x1();


            //arrow functions2
            var b = "out"
            var y = () => {
                var b = "in";
                document.write("<br><br>thisb_value_y: " + this);
                document.write("<br>b_value_y: " + b);
            }
            y();
            var y1 = () => {
                var b = "first in";
                document.write("<br>thisb_value_y1: " + this);
                document.write("<br>b_value_y1: " + b);
                var y2 = () => {
                    var b = "second in";
                    document.write("<br>thisb_value_y2: " + this);
                    document.write("<br>b_value_y2: " + b);
                }
                y2();
            }
            y1();


            //arrow functions in objects
            var firstname = "outname";
            var obj = {
                firstname : "innername",
                name1 : function(){

                    var nfun = () => document.write("<br><br>in arrw fun: "+this);
                    nfun();
                    document.write("<br>Normal fun "+this);
                }
            };
            obj.name1();


            var fname = "oname";
            var obj1 = {
                fname : "iname",
                name : () => {
                    document.write("<br><br>arrow fn: "+ this);
                    function fname(){
                        document.write("<br>normal in arrow: "+ this);
                    }
                    fname();
                }
            }
            obj1.name();

            let me = { 
                name: "pavani", 
                thisInArrow:() => { 
                    document.write("<br><br>My name is " + this.name); // no 'this' binding here 
                }, 
                thisInRegular: function(){ 
                    document.write("<br>My name is " + this.name); // 'this' binding works here 
                }
            };
            me.thisInArrow(); 
            me.thisInRegular();
            document.write("<br>Outside the function "+a);
        </script>
    </body>
</html>
